//---------------------------------------------------------------------------
// vcmame.h
//
// Header file used to compile M.A.M.E. with Visual C++
//---------------------------------------------------------------------------

#ifndef __VCMAME_H_
#define __VCMAME_H_
#pragma once

// Updated for V121u2 - 20071130

//---------------------------------------------------------------------------
// NOTE:
//
// All of the global #defines are here.
// This header is a 'forced' include in each project.
//---------------------------------------------------------------------------

#ifdef INLINE
#undef INLINE
#endif

//#define INLINE static __forceinline
#define INLINE static __inline
#define inline INLINE
#define __inline__ INLINE

#include "windows\winprefix.h"		// <-- PI and M_PI
#include <float.h>

// Needed by config.c
#ifndef CRLF
#define CRLF 3
#endif

// Disable extensions in Expat
#ifdef _MSC_EXTENSIONS
#undef _MSC_EXTENSIONS
#endif


// VC2008 Orcas has this already defined.
#if (_MSC_VER < 1500)
#ifdef vsnprintf
#undef vsnprintf
#endif
#define vsnprintf _vsnprintf
#endif

#define snprintf _snprintf

#define CLIB_DECL __cdecl
#define DECL_SPEC __cdecl

//---------------------------------------------------------------------------
// Compiler Warnings

/*  Visual C++ 2005 */
#if _MSC_VER >= 1400
#pragma warning(disable:4996)       // _CRT_SECURE_NO_WARNINGS
#endif
#pragma warning(disable:4018)		// "signed/unsigned mismatch"
#pragma warning(disable:4146)		// "unary minus operator applied to unsigned type"
#pragma warning(disable:4244)		// "possible loss of data"
#pragma warning(disable:4305)		// "truncation from 'type' to 'type'


#ifndef LSB_FIRST
#define LSB_FIRST
#endif

//---------------------------------------------------------------------------
// M68000 Core Selection
//
// NOTE : If you change anything in this section, you must "Rebuild All"

//#define A68K0						// Assembler-based M68000 CPU Core
//#define A68K2						// Assembler-based M68020 CPU Core

// Turn on/off DRC MIPS3 engine
#define X86_MIPS3_DRC 1

//---------------------------------------------------------------------------
// HAS_CPU Declarations
//
// NOTE : If you change anything in this section, you must "Rebuild All"

/*
#-------------------------------------------------
# specify available CPU cores; some of these are
# only for MESS and so aren't included
#-------------------------------------------------
*/
#define HAS_Z80 1
#define HAS_Z180 1
#define HAS_8080 1
#define HAS_8085A 1
#define HAS_M6502 1
#define HAS_M65C02 1
#define HAS_M65SC02 1
//define HAS_M65CE02 1
#define HAS_M6509 1
#define HAS_M6510 1
#define HAS_M6510T 1
#define HAS_M7501 1
#define HAS_M8502 1
#define HAS_N2A03 1
#define HAS_DECO16 1
#define HAS_M4510 1
#define HAS_H6280 1
#define HAS_I8086 1
#define HAS_I8088 1
#define HAS_I80186 1
#define HAS_I80188 1
#define HAS_I80286 1
#define HAS_V20 1
#define HAS_V25 1
#define HAS_V30 1
#define HAS_V33 1
#define HAS_V35 1
#define HAS_V60 1
#define HAS_V70 1
#define HAS_I8035 1
#define HAS_I8039 1
#define HAS_I8048 1
#define HAS_I8049 1
#define HAS_N7751 1
#define HAS_MB8884 1
#define HAS_MB58715 1
#define HAS_I8X41 1
#define HAS_I8051 1
#define HAS_I8052 1
#define HAS_I8751 1
#define HAS_I8752 1
#define HAS_DS5002FP 1
#define HAS_M6800 1
#define HAS_M6801 1
#define HAS_M6802 1
#define HAS_M6803 1
#define HAS_M6808 1
#define HAS_HD63701 1
#define HAS_NSC8105 1
#define HAS_M6805 1
#define HAS_M68705 1
#define HAS_HD63705 1
#define HAS_HD6309 1
#define HAS_M6809 1
#define HAS_M6809E 1
#define HAS_KONAMI 1
#define HAS_M68000 1
#define HAS_M68010 1
#define HAS_M68EC020 1
#define HAS_M68020 1
#define HAS_M68040 1
#define HAS_T11 1
#define HAS_S2650 1
#define HAS_TMS34010 1
#define HAS_TMS34020 1
#define HAS_TMS9900 1
//define HAS_TMS9940 1
#define HAS_TMS9980 1
//define HAS_TMS9985 1
//define HAS_TMS9989 1
#define HAS_TMS9995 1
//define HAS_TMS99105A 1
//define HAS_TMS99110A 1
#define HAS_Z8000 1
#define HAS_TMS32010 1
#define HAS_TMS32025 1
#define HAS_TMS32026 1
#define HAS_TMS32031 1
#define HAS_TMS32032 1
#define HAS_TMS32051 1
#define HAS_CCPU 1
#define HAS_ADSP2100 1
#define HAS_ADSP2101 1
#define HAS_ADSP2104 1
#define HAS_ADSP2105 1
#define HAS_ADSP2115 1
#define HAS_ADSP2181 1
#define HAS_PSXCPU 1
#define HAS_ASAP 1
#define HAS_UPD7810 1
#define HAS_UPD7807 1
#define HAS_ARM 1
#define HAS_ARM7 1
#define HAS_JAGUAR 1
#define HAS_R3000 1
#define HAS_R3041 1
#define HAS_R4600 1
#define HAS_R4650 1
#define HAS_R4700 1
#define HAS_R5000 1
#define HAS_QED5271 1
#define HAS_RM7000 1
#define HAS_SH2 1
#define HAS_SH4 1
#define HAS_DSP32C 1
#define HAS_PIC16C54 1
#define HAS_PIC16C55 1
#define HAS_PIC16C56 1
#define HAS_PIC16C57 1
#define HAS_PIC16C58 1
#define HAS_G65816 1
#define HAS_SPC700 1
#define HAS_E116T 1
#define HAS_E116XT 1
#define HAS_E116XS 1
#define HAS_E116XSR 1
#define HAS_E132N 1
#define HAS_E132T 1
#define HAS_E132XN 1
#define HAS_E132XT 1
#define HAS_E132XS 1
#define HAS_E132XSR 1
#define HAS_GMS30C2116 1
#define HAS_GMS30C2132 1
#define HAS_GMS30C2216 1
#define HAS_GMS30C2232 1
#define HAS_I386 1
#define HAS_I486 1
#define HAS_PENTIUM 1
#define HAS_MEDIAGX 1
#define HAS_I960 1
#define HAS_H83002 1
#define HAS_V810 1
#define HAS_M37702 1
#define HAS_M37710 1
#define HAS_PPC403GA 1
#define HAS_PPC403GCX 1
#define HAS_PPC601 1
#define HAS_PPC602 1
#define HAS_PPC603 1
#define HAS_PPC603E 1
#define HAS_PPC603R 1
#define HAS_MPC8240 1
#define HAS_SE3208 1
#define HAS_MC68HC11 1
#define HAS_ADSP21062 1
#define HAS_DSP56156 1
#define HAS_RSP 1
#define HAS_ALPHA8201 1
#define HAS_ALPHA8301 1
#define HAS_CDP1802 1
#define HAS_COP420 1
#define HAS_COP421 1
#define HAS_COP410 1
#define HAS_TLCS90 1
#define HAS_MB8841 1
#define HAS_MB8842 1
#define HAS_MB8843 1
#define HAS_MB8844 1
#define HAS_MB86233 1
#define HAS_SSP1601 1
#define HAS_APEXC 1
#define HAS_CP1610 1
#define HAS_F8 1
#define HAS_LH5801 1
#define HAS_PDP1 1
#define HAS_SATURN 1
#define HAS_SC61860 1
#define HAS_TX0_64KW 1
#define HAS_TX0_8KW 1
#define HAS_LR35902 1
#define HAS_TMS7000 1
#define HAS_TMS7000_EXL 1
#define HAS_SM8500 1
#define HAS_V30MZ 1
#define HAS_CXD8661R 1



/*
#-------------------------------------------------
# specify available sound cores; some of these are
# only for MESS and so aren't included
#-------------------------------------------------
*/

// uncomment the following lines to include a sound core
#define HAS_CUSTOM 1
#define HAS_SAMPLES 1
#define HAS_DAC 1
#define HAS_DMADAC 1
#define HAS_DISCRETE 1
#define HAS_AY8910 1
#define HAS_YM2203 1
// enable only one of the following two
#define HAS_YM2151 1
#define HAS_YM2608 1
#define HAS_YM2610 1
#define HAS_YM2610B 1
#define HAS_YM2612 1
#define HAS_YM3438 1
#define HAS_YM2413 1
#define HAS_YM3812 1
#define HAS_YMZ280B 1
#define HAS_YM3526 1
#define HAS_Y8950 1
#define HAS_SN76477 1
#define HAS_SN76496 1
#define HAS_POKEY 1
#define HAS_TIA 1
#define HAS_NES 1
#define HAS_ASTROCADE 1
#define HAS_NAMCO 1
#define HAS_NAMCO_15XX 1
#define HAS_NAMCO_CUS30 1
#define HAS_NAMCO_52XX 1
#define HAS_NAMCO_54XX 1
#define HAS_NAMCO_63701X 1
#define HAS_NAMCONA 1
#define HAS_TMS36XX 1
#define HAS_TMS3615 1
#define HAS_TMS5100 1
#define HAS_TMS5110 1
#define HAS_TMS5110A 1
#define HAS_CD2801 1
#define HAS_TMC0281 1
#define HAS_CD2802 1
#define HAS_M58817 1
#define HAS_TMC0285 1
#define HAS_TMS5200 1
#define HAS_TMS5220 1
#define HAS_VLM5030 1
#define HAS_ADPCM 1
#define HAS_OKIM6295 1
#define HAS_MSM5205 1
#define HAS_MSM5232 1
#define HAS_UPD7759 1
#define HAS_HC55516 1
#define HAS_K005289 1
#define HAS_K007232 1
#define HAS_K051649 1
#define HAS_K053260 1
#define HAS_K054539 1
#define HAS_SEGAPCM 1
#define HAS_RF5C68 1
#define HAS_CEM3394 1
#define HAS_C140 1
#define HAS_QSOUND 1
#define HAS_SAA1099 1
#define HAS_IREMGA20 1
#define HAS_ES5503 1
#define HAS_ES5505 1
#define HAS_ES5506 1
#define HAS_BSMT2000 1
#define HAS_YMF262 1
#define HAS_YMF278B 1
#define HAS_GAELCO_CG1V 1
#define HAS_GAELCO_GAE1 1
#define HAS_X1_010 1
#define HAS_MULTIPCM 1
#define HAS_C6280 1
#define HAS_SP0250 1
#define HAS_SCSP 1
#define HAS_YMF271 1
#define HAS_PSXSPU 1
#define HAS_CDDA 1
#define HAS_ICS2115 1
#define HAS_ST0016 1
#define HAS_NILE 1
#define HAS_C352 1
#define HAS_VRENDER0 1
//define HAS_VOTRAX 1
#define HAS_ES8712 1
#define HAS_RF5C400 1
#define HAS_SPEAKER 1
#define HAS_CDP1869 1
#define HAS_S14001A 1
#define HAS_BEEP 1
//define HAS_WAVE 1
//define HAS_SID6581 1
//define HAS_SID8580 1
#define HAS_SP0256 1
#define HAS_AICA 1



//---------------------------------------------------------------------------

// Turn off some less commonly used defines in tiny builds
#ifdef TINY_COMPILE
#include <vctiny.h>
#endif

#endif		// __VCMAME_H_
